${ var doc = require( "hopdoc" ) }
${ var path = require( "path" ) }
${ var ROOT = path.dirname( module.filename ) }

Syslog
======

This module documents the Hop.js builtin syslog api.

Use `require( hop.syslog )` to use it.

Additional information regarding `syslog` can be obtained in the Unix
man page.


Functions
---------

### syslog.open( name, option, facility ) ###
[:@glyphicon glyphicon-tag function]

Initialize the syslog connection. The `option` argument is a bit-or combination
of the following values:

 * `syslog.LOG\_CONS`: direct console writing
 * `syslog.LOG\_NDELAY`: open connection immediately
 * `syslog.LOG\_NOWAIT`: don't wait for child processes
 * `syslog.LOG\_ODELAY`: delayed opening connection until first message
 * `syslog.LOG\_PID`: include PID with each message

The value facility must be one of:

 * `syslog.LOG\_AUTH`: security/authorization messages.
 * `syslog.LOG\_AUTHPRIV`: security/authorization messages (private).
 * `syslog.LOG\_CRON`: cron messages.
 * `syslog.LOG\_DAEMON`: daemon messages.
 * `syslog.LOG\_FTP`: ftp messages.
 * `syslog.LOG\_KERN`: kernel messages.
 * `syslog.LOG\_LOCAL0`: kernel messages.
 * ...
 * `syslog.LOG\_LOCAL7`: local messages
 * `syslog.LOG\_LPR`: printing messages
 * `syslog.LOG\_MAIL`: mail messages
 * `syslog.LOG\_NEWS`: news messages
 * `syslog.LOG\_SYSLOG`: syslog messages
 * `syslog.LOG\_USER`: generic user-level messages
 * `syslog.LOG\_UUCP`: uucp messages

### syslog.log( level, msg ) ###
[:@glyphicon glyphicon-tag function]

Emit a log message. The argument `msg` is a string. The argument `level`
denotes the importance of the message. The levels are, in order of decreasing
importance:

 * `syslog.LOG\_EMARG`: system is unusable
 * `syslog.LOG\_ALERT`: action must be taken immediately
 * `syslog.LOG\_CRIT`: critical conditions
 * `syslog.LOG\_ERR`: error conditions
 * `syslog.LOG\_WARNING`: warning conditions
 * `syslog.LOG\_NOTICE`: normal but significant condition
 * `syslog.LOG\_INFO`: informational message
 * `syslog.LOG\_DEBUG`: debug-level message

### syslog.close() ###
[:@glyphicon glyphicon-tag function]

Closes the `syslog` connection.


Example
-------

${ doc.include( ROOT + "/../../../examples/syslog/README.md" ) }

${ <span class="label label-info">syslog/syslog.js</span> }

```hopscript
${ doc.include( ROOT + "/../../../examples/syslog/syslog.js", 14 ) }
```




