${ var doc = require( "hopdoc" ) }
${ var path = require( "path" ) }
${ var ROOT = path.dirname( module.filename ) }

Syslog
======

This module documents the Hop.js builtin system time api. It enables
measuring the execution time of a JavaScript fragment. It returns the
result of the evaluation, the real time (wallclock time), the system time,
and the user time.

Use `require( hop.systime )` to use it.

Additional information regarding `syslog` can be obtained in the Unix
man page.


Functions
---------

### systime.time( thunk ) ###
[:@glyphicon glyphicon-tag function]

Invoke the `thunk` procedure (a function with no argument) and returns
an object describing the evaluation. Its properties are:

  * `res`: the evaluation result.
  * `rtime`: the real time in millisecond.
  * `stime`: the system time in millisecond.
  * `utime`: the user time in millisecond.
  

Example
-------

${ doc.include( ROOT + "/../../../examples/systime/README.md" ) }

${ <span class="label label-info">systime/systime.js</span> }

```hopscript
${ doc.include( ROOT + "/../../../examples/systime/systime.js", 14 ) }
```




